﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Program
{
    public abstract class Djeltnik : IComparable<Djeltnik>, IComparer<Djeltnik>
    {
        protected Djeltnik(int jmbag, string ime, string prezime, int godineStaza)
        {
            Jmbag = jmbag;
            Ime = ime;
            Prezime = prezime;
            GodineStaza = godineStaza;
        }

        private int jmbag;

        private int Jmbag 
        {
            get => jmbag;
            set
            {
                if (value.ToString().Length != 5)
                {
                    throw new Exception("JMBAG mora biti 5 znamenki");
                }
                //if (value[0] + value[4] != 9)
                //{
                //    throw new Exception("Suma prvog i petog broja JMBAG-a mora biti 9");
                //}
                jmbag = value;

            }
        }
        public string Ime { get; set; }
        public string Prezime { get; set; }
        public int GodineStaza { get; set; }

        public override bool Equals(object obj)
        {
            return obj is Djeltnik djeltnik &&
                   Jmbag == djeltnik.Jmbag;
        }

        public override int GetHashCode()
        {
            return 2017862598 + Jmbag.GetHashCode();
        }

        public int CompareTo(Djeltnik other)
        => -GodineStaza.CompareTo(other.GodineStaza);

        public int Compare(Djeltnik x, Djeltnik y)
        => x.Prezime.CompareTo(y.Prezime);
    }
}
